using System;
using System.Collections.Generic;

namespace P28_2
{
    /// <summary>
    ///  IServiceProvider  .      App.Services
    ///     ContentManagers   ,     IServiceProvider.
    /// </summary>
    public class AppServiceProvider : IServiceProvider
    {
        //      
        private readonly Dictionary<Type, object> services = new Dictionary<Type, object>();

        /// <summary>
        ///     .
        /// </summary>
        /// &lt;param name="serviceType"&gt;  .</param>
        /// &lt;param name="service"&gt;  .</param>
        public void AddService(Type serviceType, object service)
        {
            //   
            if (serviceType == null)
                throw new ArgumentNullException("serviceType");
            if (service == null)
                throw new ArgumentNullException("service");
            if (!serviceType.IsAssignableFrom(service.GetType()))
                throw new ArgumentException("service does not match the specified serviceType");

            //    
            services.Add(serviceType, service);
        }

        /// <summary>
        ///     .
        /// </summary>
        /// &lt;param name="serviceType"&gt;  .</param>
        /// <returns> ,    .</returns>
        public object GetService(Type serviceType)
        {
            //   
            if (serviceType == null)
                throw new ArgumentNullException("serviceType");

            //    
            return services[serviceType];
        }

        /// <summary>
        ///     .
        /// </summary>
        /// &lt;param name="serviceType"&gt;  .</param>
        public void RemoveService(Type serviceType)
        {
            //   
            if (serviceType == null)
                throw new ArgumentNullException("serviceType");

            //    
            services.Remove(serviceType);
        }
    }
}
